-module(element_email).
%%-author('Vladimir Galunshchikov').

-include_lib("nitro/include/nitro.hrl").

-compile([export_all, nowarn_export_all]).


render_element(Record) ->
  Id = case Record#email.postback of
    undefined -> Record#email.id;
    Postback ->
      ID0 = case Record#email.id of
        undefined -> nitro:temp_id();
        I -> I
      end,
      nitro:wire( #event{type = click, postback = Postback, target = ID0,
                         source = Record#email.source, delegate = Record#email.delegate} ),
      ID0
  end,
  List = [
    %% global
    {<<"accesskey">>, Record#email.accesskey},
    {<<"class">>, Record#email.class},
    {<<"contenteditable">>,
       case Record#email.contenteditable of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"contextmenu">>, Record#email.contextmenu},
    {<<"dir">>,
       case Record#email.dir of
         "ltr" -> "ltr";
         "rtl" -> "rtl";
         "auto" -> "auto";
         _ -> undefined
       end},
    
    {<<"draggable">>,
       case Record#email.draggable of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"dropzone">>, Record#email.dropzone},
    {<<"hidden">>,
       case Record#email.hidden of
         "hidden" -> "hidden";
         _ -> undefined
       end},
    
    {<<"id">>, Id},
    {<<"lang">>, Record#email.lang},
    {<<"spellcheck">>,
       case Record#email.spellcheck of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"style">>, Record#email.style},
    {<<"tabindex">>, Record#email.tabindex},
    {<<"title">>, Record#email.title},
    {<<"translate">>,
       case Record#email.contenteditable of
         "yes" -> "yes";
         "no" -> "no";
         _ -> undefined
       end},
    
    %% spec
    {<<"autocomplete">>,
       case Record#email.autocomplete of
         true -> "on";
         false -> "off";
         _ -> undefined
       end},
    
    {<<"autofocus">>,
       case Record#email.autofocus of
         true -> "autofocus";
         _ -> undefined
       end},
    
    {<<"disabled">>,
       case Record#email.disabled of
         true -> "disabled";
         _ -> undefined
       end},
    
    {<<"form">>, Record#email.form},
    {<<"list">>, Record#email.list},
    {<<"maxlength">>, Record#email.maxlength},
    {<<"multiple">>,
       case Record#email.multiple of
         true -> "multiple";
         _ -> undefined
       end},
    
    {<<"name">>, Record#email.name},
    {<<"pattern">>, Record#email.pattern},
    {<<"placeholder">>, Record#email.placeholder},
    {<<"readonly">>,
       case Record#email.readonly of
         true -> "readonly";
         _ -> undefined
       end},
    
    {<<"required">>,
       case Record#email.required of
         true -> "required";
         _ -> undefined
       end}, 
    
    {<<"size">>, Record#email.size},
    {<<"type">>, <<"email">>},
    {<<"value">>, Record#email.value} | Record#email.data_fields
  ],
  
  wf_tags:emit_tag(<<"input">>, nitro:render(Record#email.body), List).

