-module(element_month).
%%-author('Vladimir Galunshchikov').

-include_lib("nitro/include/nitro.hrl").

-compile([export_all, nowarn_export_all]).


render_element(Record) ->
  Id = case Record#month.postback of
    undefined -> Record#month.id;
    Postback ->
      ID0 = case Record#month.id of
        undefined -> nitro:temp_id();
        I -> I
      end,
      nitro:wire( #event{type = click, postback = Postback, target = ID0,
                         source = Record#month.source, delegate = Record#month.delegate} ),
      ID0
  end,
  List = [
    %% global
    {<<"accesskey">>, Record#month.accesskey},
    {<<"class">>, Record#month.class},
    {<<"contenteditable">>,
       case Record#month.contenteditable of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"contextmenu">>, Record#month.contextmenu},
    {<<"dir">>,
       case Record#month.dir of
         "ltr" -> "ltr";
         "rtl" -> "rtl";
         "auto" -> "auto";
         _ -> undefined
       end},
    
    {<<"draggable">>,
       case Record#month.draggable of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"dropzone">>, Record#month.dropzone},
    {<<"hidden">>,
       case Record#month.hidden of
         "hidden" -> "hidden";
         _ -> undefined
       end},
    
    {<<"id">>, Id},
    {<<"lang">>, Record#month.lang},
    {<<"spellcheck">>,
       case Record#month.spellcheck of
         true -> "true";
         false -> "false";
         _ -> undefined
       end},
    
    {<<"style">>, Record#month.style},
    {<<"tabindex">>, Record#month.tabindex},
    {<<"title">>, Record#month.title},
    {<<"translate">>,
       case Record#month.contenteditable of
         "yes" -> "yes";
         "no" -> "no";
         _ -> undefined
       end},
    
    %% spec
    {<<"alt">>, Record#month.alt},
    {<<"autofocus">>,
       case Record#month.autofocus of
         true -> "autofocus";
         _ -> undefined
       end},
    
    {<<"disabled">>,
       case Record#month.disabled of
         true -> "disabled";
         _ -> undefined
       end},
    
    {<<"form">>, Record#month.form},
    {<<"max">>, Record#month.max},
    {<<"min">>, Record#month.min},
    {<<"name">>, Record#month.name},
    {<<"readonly">>,
       case Record#month.readonly of
         true -> "readonly";
         _ -> undefined
       end},
    
    {<<"required">>,
       case Record#month.required of
         true -> "required";
         _ -> undefined
       end},
    
    {<<"step">>, Record#month.step},
    {<<"type">>, <<"month">>},
    {<<"value">>, Record#month.value} | Record#month.data_fields
  ],
  
  wf_tags:emit_tag(<<"input">>, nitro:render(Record#month.body), List).

